class dot:
  header = 'graph topology {'
  footer = '}'

  def __init__(self, filename='test.dot'):
    self.filename = filename
    self.links = []


  def addlink(self, src, dst, label='', style ='solid', color='black'):
    str = '"%s" -- "%s" [label="%s", style="%s", color="%s"];' % (src, dst, label, style, color)
    self.links.append(str)

  def save(self):  
    f = open(self.filename, 'w')
    f.write(self.header+'\n')
    for str in self.links[:]:
      f.write(str+'\n')
    f.write(self.footer+'\n')
    f.close()  

    

