import commands
import os
import re
import scapy
import socket
import sys

INTERFACE = 'eth*|tun*'
NET = 'fec1::/120'
FILENAME = 'mac.txt'

scapy.conf.verb = 0
reply = ''
devnull = open('/dev/null', 'w')
sys.stderr = devnull
sys.stdout = devnull

def filter_if_list(filter):
      ifl = scapy.get_if_list()
      ret = []
      rec = re.compile(filter)
      for i in ifl:
	  if rec.match(i):
	     ret.append(i)
      return ret

def forker(iface):
    rep = ''
    scapy.conf.iface = iface

    SRC = 'fec0::254'
    commands.getoutput('/sbin/ifconfig %s 0.0.0.0 up' % iface)
    ns = scapy.ICMPv6MessageNeighbor(sa=NET)/scapy.ICMPv6MessageNeighborOption(lladdr='1:2:3:4:5:6', len=1, lltype=1)
    p = scapy.IPv6(src='fec0::254', hoplim=255)/scapy.ICMPv6(type=135)/ns

    ans, unans = scapy.sr(p, timeout=2)
    
    if not ans == []: # Only get the first answer
	s,r = ans.pop()
	rep = r.sprintf("%ICMPv6MessageNeighbor.sa% "+iface+" %ICMPv6MessageNeighborOption.lladdr%\n")
    return rep

ifl = filter_if_list(INTERFACE)

for i in ifl:
    print i
    reply += forker(i)

f = open(FILENAME, 'w')
f.write(reply)
f.close()
