import commands
import os
import re
import scapy
import sys

INTERFACE = 'eth[1-9]|tun*'
NET = '192.168.0.0/24'
FILENAME = 'mac.txt'

scapy.conf.verb = 0
reply = ''
devnull = open('/dev/null', 'w')
sys.stderr = devnull
sys.stdout = devnull

def filter_if_list(filter):
    ifl = scapy.get_if_list()
    ret = []
    rec = re.compile(filter)
    for i in ifl:
	if rec.match(i):
	     ret.append(i)
    return ret

def forker(iface):
    #pid = os.fork()
    #if pid != 0:
	rep = ''
	commands.getoutput('/sbin/ifconfig %s %s' % (iface, '192.168.0.254'))
	scapy.conf.route.add(net=NET, dev=iface)
	scapy.conf.iface = iface
	
	ans, unans = scapy.srp(scapy.Ether(dst="ff:ff:ff:ff:ff:ff")/
			       scapy.ARP(pdst=NET),
			       filter="arp and arp[7] = 2", timeout=2, iface=iface)
	if not ans == []: # Only get the first answer
	    s,r = ans.pop()
	    rep = r.sprintf("%ARP.psrc% "+iface+" %Ether.src%\n")
	scapy.conf.route.delt(net=NET, dev=iface)
	commands.getoutput('/sbin/ifconfig %s 0.0.0.0' % iface)
	return rep
	#sys.exit()

ifl = filter_if_list(INTERFACE)

for i in ifl:
    reply += forker(i)

f = open(FILENAME, 'w')
f.write(reply)
f.close()
